#include "header.h"


void *reader(void *parm)
{

	int num_p = (int ) (long )parm;
        unsigned long cksum_r = 0;
        unsigned long *ulptr_r;
        int     i, num_r, num_w;
        char    *ptr, *buff;
	char    read_from_mem;

	
        num_r = num_p % num_readers;
        num_w = num_p - num_r;
        num_w = num_w / num_readers;

        ptr =  shmaddr[num_w];
        ulptr_r = (unsigned long *)shmaddr[num_w];

	
        if(pthread_mutex_lock (&cond_mutex[num_w]))
                perror("Can't Take Cond Lock");

        while(thread_hold[num_w])
        {
                if(pthread_cond_wait(&cond_var[num_w], &cond_mutex[num_w]))
                        perror("cond_wait failed");
        }

        if(pthread_mutex_unlock(&cond_mutex[num_w]))
                perror("Release cond Lock Failed");

        if(pthread_mutex_lock(&mutex_r[num_w]))
                perror("Can't take read Lock");


        read_count++; 

        if(pthread_mutex_unlock(&mutex_r[num_w]))
                perror("Can't Release Read Lock");


        for(i = 0; i < buffer_size; i++)
                cksum_r += *ptr;


        if(pthread_mutex_lock(&mutex_r[num_w]))
                perror("Can't Take Read Lock");

 
	read_count--; 


        if(pthread_mutex_unlock(&mutex_r[num_w]))
                perror("Can't Release 1 Read Lock");

/*        *ulptr_r = cksum_r;*/

        printf("\tReader (%d) of Writer (%d): checksum %04ld\n",\
                                                num_r, num_w, cksum_w);
	

        return NULL;


}
